package net.monarchpass.piecannon.impl;

import net.monarchpass.piecannon.Server;
import com.google.common.io.ByteSource;
import com.google.common.io.ByteStreams;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.net.URI;
import java.net.URL;
import java.net.URLConnection;

import lombok.Data;

@Data
public class FtpServer implements Server {
    private final String label;
    private final String host;
    private final int port;
    private final String username;
    private final String password;
    private final String path;
    private final URI uri;
    
    public URI upload (String name, ByteSource source) {
        name = name.replace(" ", "%20");
        
        try {
            final URI target = URI.create(uri.toString() + "/" + name);
            final URL ftpUrl = new URL(String.format("ftp://%s:%s@%s:%d/%s/%s;type=i", username, password, host, port, path, name));
            final URLConnection connection = ftpUrl.openConnection();
            
            try (InputStream in = source.openStream()) {
                try (OutputStream out = connection.getOutputStream()) {
                    ByteStreams.copy(in, out);
                }
            }
            
            return target;
        } catch (final IOException exception) {
            throw new RuntimeException(exception);
        }
    }
}
