package net.monarchpass.piecannon.impl;

import java.net.URI;
import java.util.Map;

import com.google.common.io.ByteSource;
import com.google.gson.Gson;

import jodd.http.HttpRequest;
import lombok.Data;
import net.monarchpass.piecannon.Server;
import net.monarchpass.piecannon.util.ByteSourceUploadable;

@Data
public class GoFileServer implements Server {
    public static final String DEFAULT_HOST = "gofile.io";
    public static final String DEFAULT_API_HOST = "apiv2." + DEFAULT_HOST;
    
    private final Gson gson = new Gson();
    private final String label;
    private String host = DEFAULT_HOST;
    private  String apiHost = DEFAULT_API_HOST;
    
	@Override
	public URI upload (String name, ByteSource source) {
        Response response = request(HttpRequest.get(String.format("https://%s/getServer", apiHost)));
        
        final String serverId = (String)response.getData().get("server");
        response = request(HttpRequest.post(String.format("https://%s.%s/uploadFile", serverId, host))
            .form("file", new ByteSourceUploadable(name, source)));
        
        final String code = (String)response.getData().get("code");
		final URI uri = URI.create(String.format("https://%s/d/%s", host, code));
		return uri;
	}
	
	private Response request (final HttpRequest request) {
        return gson.fromJson(request.send().bodyText(), Response.class);
	}
	
	@Data
	public static class Response {
        public final String status;
        public final Map<String, Object> data;
	}
}
