package net.monarchpass.piecannon.util;

import java.io.IOException;
import java.io.InputStream;

import com.google.common.io.ByteSource;

import jodd.http.HttpException;
import jodd.http.upload.Uploadable;
import lombok.Data;

@Data
public class ByteSourceUploadable implements Uploadable<ByteSource> {
    private final String fileName;
    private final ByteSource source;
    
    @Override
    public ByteSource getContent () {
        return source;
    }

    @Override
    public byte[] getBytes () {
        try {
            return source.read();
        } catch (final IOException exception) {
            throw new HttpException(exception);
        }
    }

    @Override
    public String getFileName () {
        return fileName;
    }

    @Override
    public String getMimeType () {
        return null;
    }

    @Override
    public int getSize () {
        try {
            return (int) source.size();
        } catch (final IOException exception) {
            throw new HttpException(exception);
        }
    }

    @Override
    public InputStream openInputStream () throws IOException {
        return source.openStream();
    }
}
