package net.monarchpass.piecannon;

import java.net.URI;
import org.junit.jupiter.api.Test;
import net.monarchpass.piecannon.impl.SftpServer;

import static com.google.common.truth.Truth.assertThat;

public class SftpTest {
    @Test
    public void test () throws Exception {
        final String testServerHost = System.getProperty("piecannon.test.host");
        if (testServerHost == null) {
            return;
        }
        
        final String testServerUser = System.getProperty("piecannon.test.user");
        final String testServerPassword = System.getProperty("piecannon.test.password");
        final String testServerPath = System.getProperty("piecannon.test.path");
        final String testServerURL = System.getProperty("piecannon.test.url");
        
        final Server server = new SftpServer(
            "Test Server Instance", testServerHost, 22,
            testServerUser, testServerPassword, testServerPath,
            URI.create(testServerURL)
        );
        
        assertThat(PieCannon.testServer(server)).isTrue();
    }
}
